#include "mybutton.h"
#include <QMimeData>
#include <QDragEnterEvent>
#include <iostream>
using namespace std;

MyButton::MyButton(QWidget *parent) :
    QPushButton(parent)
{
    setAcceptDrops (true); // <-- important
}

void MyButton::dragEnterEvent(QDragEnterEvent *event)
{
    const QMimeData * data = event->mimeData();
    if (data->hasColor())
    {
       event->acceptProposedAction(); // <-- important
       setText ("color");
       cout << "dragEnter" << endl;
    }
}

void MyButton::dropEvent(QDropEvent *event)
{
    const QMimeData * data = event->mimeData();
    if (data->hasColor())
    {
       QColor color = data->colorData().value <QColor> ();
       setText ("drop " + color.name ());
       cout << "drop" << endl;
    }
}

