#include "mytree.h"
#include <QMimeData>
#include <iostream>
using namespace std;

MyTree::MyTree(QWidget *parent) :
    QTreeWidget (parent)
{
   setAcceptDrops (true); // <-- important
   setDropIndicatorShown (true);
   // setDragEnabled(true);
   // setDragDropMode(DropOnly);
   // setDragDropMode(DragOnly);
   // setDragDropMode(DragDrop);
   // setDragDropMode(InternalMove);

   QTreeWidgetItem * root = new QTreeWidgetItem (this);
   root->setText(0, "root");
   // root->setFlags(root->flags() | Qt::ItemIsDropEnabled);
   // addTopLevelItem (root);

   for (int i = 1; i <= 3; i ++)
   {
      QTreeWidgetItem * item = new QTreeWidgetItem (root);
      item->setText(0, "item " + QString::number (i));
      // root->addChild (item);
   }

   expandAll ();
}

QStringList MyTree::mimeTypes() const // <-- importatnt
{
    return QStringList () << "text/plain" << "application/x-color";
}

Qt::DropActions MyTree::supportedDropActions() const
{
   return Qt::MoveAction | Qt::CopyAction  | Qt::LinkAction;
}

bool MyTree::dropMimeData(QTreeWidgetItem *target, int index, const QMimeData *data, Qt::DropAction action)
{
    bool result = false;
    cout << "dropMimeData" << endl;

    if (data->hasText() || data->hasColor ())
    {
        QTreeWidgetItem * item = new QTreeWidgetItem (target);
        item->setText (0, "new item");
        if (data->hasText())
            item->setText (0, data->text());
        if (data->hasColor())
        {
            QColor color = data->colorData().value <QColor> ();
            item->setForeground (0, color);
        }
        if (target == nullptr)
            addTopLevelItem(item);
        else
            target->addChild (item);
        result = true;
    }


    return result;
}

